
import java.util.ArrayList;
import java.util.Calendar;

public class Kello extends Thread {
    private int sekunti;
    private int minuutti;
    private int tunti;
    
    private ArrayList<Observer> tarkkailijat;

    public Kello() {
        tarkkailijat = new ArrayList<Observer>();
        reset();
    }

    public void reset() {
        sekunti = Calendar.getInstance().get(Calendar.SECOND);
        minuutti = Calendar.getInstance().get(Calendar.MINUTE);
        tunti = Calendar.getInstance().get(Calendar.HOUR_OF_DAY);
    }
            
    @Override
    public String toString() {
        return etunolla(tunti)+":"+etunolla(minuutti)+":"+etunolla(sekunti);
    }

    public void aloitaTarkkailu(Observer tarkkailija){
        tarkkailijat.add(tarkkailija);
    }    
    
    @Override
    public void run() {
        while ( true ) {
            odotaSekuntti();
            etene();
        }
    }
    
    private void ilmoitaTarkkailijoille() {
        for (Observer tarkkailija : tarkkailijat) {
            tarkkailija.update(this);
        }
    }
    
    private  void etene() {        
        sekunti++;
        if ( sekunti==60 ) 
            eteneMinuutti();
        ilmoitaTarkkailijoille();
    }    

    private void odotaSekuntti() {
        try {
            Thread.sleep(1000);
        } catch (InterruptedException ex) {}
    }    
    
    private String etunolla(int luku) {
        String nolla = luku<10 ? "0" : "";
        
        return nolla+luku;
    }

    private void eteneMinuutti() {
        sekunti = 0;
        minuutti++;
        if ( minuutti==60 ) 
            eteneTunti();
    }

    private void eteneTunti() {
        minuutti = 0;
        tunti = tunti<24 ? tunti+1 : 0;
    }
        
}
